
#ifndef _dtypes_h
#define _dtypes_h

#include <stdlib.h> /* For RAND_MAX */

//define a byte 
typedef signed char byte;

//define unsigned types
typedef unsigned char  ubyte;
typedef unsigned short ushort;
typedef unsigned int   uint;
typedef unsigned long  ulong;

//Extended range types
#if defined(HAVE_LONG_64) || defined(HAVE_LONG_LONG_64)
#  define HAVE_INT64
#endif

#ifdef HAVE_LONG_64 /* For 64 bit machines */
typedef   unsigned long        uint64;
typedef   long                 int64;
#endif
#ifdef HAVE_LONG_LONG_64 /* For 32 bit machines */
typedef   unsigned long long   uint64;
typedef   long long            int64;
#endif

//define a boolean
typedef int  bool;

#ifndef False
#  define       False   0
#endif
#ifndef True
#  define       True    1
#endif

#ifndef NULL
#  define NULL 0
#endif

typedef struct Rect {int x; int y; int w; int h; } Rect, *WindowPtr;


//Random number with restricted range, constants
#define RR_RAND_MAX (32767 & RAND_MAX)
#define RR_RAND(x) ((x) & RR_RAND_MAX)
//Could use shifts (see man rand why), but then we need to check the size of RAND_MAX etc.
#define RR_RAND_SHIFT 15 /* for user range reduction without using /(RR_RAND_MAX+1) */

//Restricted range random number
#define rr_rand() RR_RAND(rand())

#endif /* _dtypes_h */
